#include <iostream>
#include <memory>
#include <boost/thread.hpp>

class Test {
private:
    std::shared_ptr<boost::thread> m_thread;
public:
    void test();
    void threadEntry();
};

void Test::test() {
    std::cout << "starting\n";
    m_thread.reset(new boost::thread(boost::bind(&Test::threadEntry, this)));
    m_thread->join();
    m_thread.reset();
    std::cout << "finishing\n";
}

void Test::threadEntry() {
    std::cout << "enter thread\n";
    boost::this_thread::sleep(boost::posix_time::seconds(1));
    std::cout << "exit thread\n";
}

int main() {
    Test test;
    test.test();
}